/****************************************************************************/
/* 						Program 6 ASC										*/
/* Acest program foloseste lucrul in "intrerupere" ~ intrerupere generata de*/
/* Timerul T0 la fiecare 1ms, dupa urmatorul calcul:						*/
/* 65535us-1000us=64535=FC17(hexa); Astfel, la fiecare milisecunda,			*/
/* se intra in rutina de intrerupere unde are loc complementarea "buz"-ului	*/
/* si incarcarea Timerului T0 cu o noua valoare FC17, care sa determine 	*/
/* peste alta milisecunda, programul sa intre in intrerupere				*/
/* In bucla principala de program se complementeaza "gigi", la viteza de 	*/
/* lucru a microprocesorului, ~de obicei in bucla principala de program 	*/
/* se executa operatii rapide(dar trebuie avut in vedere ca aceste operatii)*/
/* pot fi intrerupte la intrarea in "intrerupere". Cel mai adesea in aceasta*/
/* zona are loc o citire de tastatura, afisare, etc.)						*/				
/****************************************************************************/

#include <reg513.h>			// foloseste Registrii cu Functii Speciale ale microcontrolerului C513 - INFINEON          
sbit buz = P3^4;  			// etichetez pinul P3^4
sbit gigi = P3^0;		  	// etichetez pinul P3^0
void init (void);			// declar functia init - folosita la initializarea Timerului 0 al acestui microcontroler
void intrerupere (void);
												
void main (void)  			// bucla principala de program
{
	init(); 				// apeleaza functia init	
	while(1)
		{
			gigi = ~gigi;	// ramaii in aceasta bucla tot timpul!
		}
}

void intrerupere (void)	interrupt 1
{
	buz = ~buz;		// complementez pinul de port P3^4
	TR0 = 0;		// opresc Timerul T0
	TF0 = 0;		// sterg flagul ce s-a setat la depasirea Timerului T0
	TH0 = 0xFC;		// 65535-1000=64535us=FC17 (in hexa) [incarc octetul superior]
	TL0 = 0x17;		// [incart octetul inferior al timerului T0]
	TR0 = 1;		// pornesc Timerul T0
}

void init (void) 
{					// configurez Timerul T0 sa lucreze pe 16 biti (cu incrementare la 1us) -
	TMOD 	= 0x01;	// 			fiind pe 16 biti
	TF0		= 0;	// flag din Registrul TCON - flag ce anunta autodepasirea Timerului
	ET0		= 1;	// bit din Registrul IE - activeaza intreruperea genegata de Timerul T0
	EAL		= 1;	// ( EA ) - bit din Registrul IE - activeaza GLOBAL intreruperile 
	TR0		= 1;   	// pornesc Timerul T0 !
}// nu este suficient sa activam global intreruperile, mai trebuie activat individual si intreruperea
 // Timerului T0 - ce are loc la fiecare autodepasire (exp. la trecerea de le valoarea 0xFFFF -> 0x0000).
